import { value, computed, watch, onBeforeMount } from 'vue-function-api';

export default (store: any, state: any) => {
    const options = value({});
    const setPage = (plus: true) => {
        if (plus) {
            page.value++;
        } else {
            page.value--;
        }
    };
    onBeforeMount(() => {
        options.value = state.pagination;
    });
    watch(
        () => options.value,
        (v: any) => {
            if (v.page) {
                store.commit('updatePagination', {
                    sortBy: v.sortBy,
                    sortDesc: v.sortDesc,
                });
                store.dispatch('getData');
            }
        },
    );
    const items = computed(() => state.items);
    const page = computed(
        () => state.pagination.page,
        (v: number) => {
            store.commit('updatePagination', { page: v });
        },
    );
    const totalItems = computed(() => state.totalItems);
    return {
        items,
        totalItems,
        options,
        page,
        setPage,
    };
};
