// Utilities
import { Store, CommitOptions, DispatchOptions } from 'vuex';
export const set = (property: string) => (state: any, payload: any) =>
    (state[property] = payload);
export const merge = (property: string) => (state: any, payload: any) =>
    (state[property] = Object.assign({}, state[property], payload));

export const toggle = (property: string) => (state: any) =>
    (state[property] = !state[property]);

export const builCommit = (s: Store<any>) => (m?: string) => (c: string) => (
    v: any,
) => s.commit(`${m ? m + '/' : ''}${c}`, v);

export const builActions = (s: Store<any>) => (m?: string) => (
    dispatch: string,
) => (value?: any) => s.dispatch(`${m ? m + '/' : ''}${dispatch}`, value);

export const vuexModule = <T>(s: Store<any>, mod: string) => {
    return {
        commit: (type: string, payload?: any, options?: CommitOptions) =>
            s.commit(`${mod}/${type}`, payload, options),
        dispatch: (type: string, payload?: any, options?: DispatchOptions) =>
            s.dispatch(`${mod}/${type}`, payload, options),
        getters: (type: string) => s.getters[`${mod}/${type}`],
        state: s.state[mod] as T,
    };
};
